//  Author : Christian Arild Str Andersen
//  			De Data Pty Ltd
//  Created : Mid 2003
//
// A guid genetator used to generate guids on WCE devices
//
// DDGuid.h: interface for the DDGuid class.
//
//////////////////////////////////////////////////////////////////////
#include "wincrypt.h"
#if !defined(AFX_DDGUID_H__C5A42EC6_D382_4E32_9ACF_3BB322301138__INCLUDED_)
#define AFX_DDGUID_H__C5A42EC6_D382_4E32_9ACF_3BB322301138__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "Windows.h"

// I cant get the wincrypt.h file to work
extern "C"
{
typedef unsigned long HCRYPTPROV;

#define PROV_RSA_FULL           1
#define CRYPT_VERIFYCONTEXT     0xF0000000

WINADVAPI
BOOL
WINAPI
CryptAcquireContextA(
    HCRYPTPROV *phProv,
    LPCSTR pszContainer,
    LPCSTR pszProvider,
    DWORD dwProvType,
    DWORD dwFlags);
WINADVAPI
BOOL
WINAPI
CryptAcquireContextW(
    HCRYPTPROV *phProv,
    LPCWSTR pszContainer,
    LPCWSTR pszProvider,
    DWORD dwProvType,
    DWORD dwFlags);
#ifdef UNICODE
#define CryptAcquireContext  CryptAcquireContextW
#else
#define CryptAcquireContext  CryptAcquireContextA
#endif // !UNICODE

WINADVAPI
BOOL
WINAPI
CryptReleaseContext(
    HCRYPTPROV hProv,
    DWORD dwFlags);

WINADVAPI
BOOL
WINAPI
CryptGenRandom(
    HCRYPTPROV hProv,
    DWORD dwLen,
    BYTE *pbBuffer);



typedef struct _DDGUID
{
    unsigned long        Data1;
    unsigned short       Data2;
    unsigned short       Data3;
    unsigned char        Data4[8];
} DDGUID;

}


#define DDGUIDSIZE 16
#define DDSTRSIZE 40
#define DDVARIANTBYTE 8
#define DDVARIANTMASK 0x3f
#define DDVARIANTSHIFT 4

#define DDVERSIONBYTE 7
#define DDVERSIONMASK 0x0f
#define DDVERSIONSHIFT 4

#define GUIDVARIANTSTANDARD 0x02
#define GUIDVERSIONRANDUM   0x04

class CDDGuid
{
private:

public:


	BOOL GenGUID();
	CDDGuid();
	virtual ~CDDGuid();
	BYTE m_GUID[DDGUIDSIZE];
	CHAR m_GuidStr[DDSTRSIZE];
};

#endif // !defined(AFX_DDGUID_H__C5A42EC6_D382_4E32_9ACF_3BB322301138__INCLUDED_)
